//
//  ViewController.m
//  E8
//
//  Created by Alejandro Reimondo on 19/7/16.
//  Copyright © 2016 Alejandro Reimondo. All rights reserved.
//

#import "ViewController.h"
#include <JavaScriptCore/JavaScriptCore.h>

int evalJSFile(JSGlobalContextRef ctx, NSString *aFileName, JSValueRef *returnValue)
{
    NSString *path = [NSString stringWithFormat:@"%@/%@"
                      ,[[NSBundle mainBundle] bundlePath]
                      ,aFileName];
    
    NSError*	error;
    id script = [NSString stringWithContentsOfFile:path encoding:NSUTF8StringEncoding error:&error];
    if (script == nil)	return	0;
    
    JSStringRef scriptJS	= JSStringCreateWithCFString((__bridge CFStringRef)script);
    JSStringRef scriptPath	= JSStringCreateWithUTF8CString([path UTF8String]);
    
    JSValueRef	exception = NULL;
    JSValueRef result = JSEvaluateScript(ctx, scriptJS, NULL, scriptPath, 1, &exception);
    if (returnValue)	*returnValue = result;
    JSStringRelease(scriptPath);
    JSStringRelease(scriptJS);
    if (exception)
    {
        NSLog(@"JSException - %@", exception);
        return	0;
    }
    JSGarbageCollect(ctx);
    return	1;
}

@interface ViewController ()

@end

@implementation ViewController

- (void)loadAll {
    JSGlobalContextRef	ctx;
    ctx = JSGlobalContextCreate(NULL);
    evalJSFile(ctx, @"prologue.js", NULL);
    evalJSFile(ctx, @"default.snapshot.js", NULL);
    evalJSFile(ctx, @"default.app.js", NULL);
}


- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    [self performSelector:@selector(loadAll) withObject:nil afterDelay:0.5];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
